/*
 *   MAPA - direct's tools
 *
 *   (c) 2000 Jan Lana (jlan3028@ss1000.ms.mff.cuni.cz)
 *
 *   $Id: direct.c,v 1.3 2001/03/26 19:53:55 mapa Exp $
 */

#include "ml.h"

#ifndef G_CAN_INLINE
G_INLINE_FUNC MLFFloat ml_directf_calc (MLFFloat d, MLFFloat n, MLFFloat exp)
{
  g_assert (n != ML_DIRECTF_UNKNOWN);

  if (d == ML_DIRECTF_UNKNOWN)
    return n;

  if (n<d) {
    if (d-n > ML_FIXED_1*4)
      n += ML_FIXED_1*8;
  } else
    if (n-d > ML_FIXED_1*4)
      n -= ML_FIXED_1*8;

  d *= exp;
  d += n*(ML_FIXED_1-exp);
  if (d < 0)
    d += ML_FIXED_1*ML_FIXED_1*8;
  else if (d > ML_FIXED_1*ML_FIXED_1*8)
    d -= ML_FIXED_1*ML_FIXED_1*8;

  return (d >> ML_FSHIFT);
}


G_INLINE_FUNC MLFFloat ml_directb_diff (MLFFloat a, MLFFloat b)
{
  register MLFFloat diff;

  g_assert (a != ML_DIRECTB_UNKNOWN || b != ML_DIRECTB_UNKNOWN);

  diff = (a==ML_DIRECTB_UNKNOWN || b==ML_DIRECTB_UNKNOWN) ? 0 : ABS_DIFF (a,b);
  
  return (diff > 4) ? 8 - diff : diff;
}


G_INLINE_FUNC MLFFloat ml_directf_diff (MLFFloat a, MLFFloat b)
{
  register MLFFloat diff;

  g_assert (a != ML_DIRECTF_UNKNOWN || b != ML_DIRECTF_UNKNOWN);

  diff = (a==ML_DIRECTF_UNKNOWN || b==ML_DIRECTF_UNKNOWN) ? 0 : ABS_DIFF (a,b);

  return (diff > ML_FIXED_1 * 4) ? ML_FIXED_1 * 8 - diff : diff;
}
#endif	/* G_INLINE_FUNC */
