/*
 *   MAPA - find lines in picture
 *
 *   (c) 2000 Jan Lana (jlan3028@ss1000.ms.mff.cuni.cz)
 *
 *   $Id: lfind.c,v 1.14 2001/04/19 15:35:56 mapa Exp $
 */

#include <string.h>

#include "ml.h"

#define Z0(thin,coord) ( \
  (!ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)) 		\
   && ML_THIN_LINE(ML_PIC_PIXEL1(thin,coord))) +	\
  (!ML_THIN_LINE(ML_PIC_PIXEL1(thin,coord))		\
   && ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord))) +	\
  (!ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord))		\
   && ML_THIN_LINE(ML_PIC_PIXEL3(thin,coord))) +	\
  (!ML_THIN_LINE(ML_PIC_PIXEL3(thin,coord))		\
   && ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord))) +	\
  (!ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord))		\
   && ML_THIN_LINE(ML_PIC_PIXEL5(thin,coord))) +	\
  (!ML_THIN_LINE(ML_PIC_PIXEL5(thin,coord))		\
   && ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord))) +	\
  (!ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord))		\
   && ML_THIN_LINE(ML_PIC_PIXEL7(thin,coord))) +	\
  (!ML_THIN_LINE(ML_PIC_PIXEL7(thin,coord))		\
   && ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)))) 

  
  
static inline void change_thin (MLPictureUI8 *thin, MLCoord *row, 
    MLCoord count, guint8 new)
{
  MLCoord i,coord;
  guint8 dir;

  for (i = 0; i < count; i++) {
    dir = ML_DIRECTB_UNKNOWN;
    coord = row[i];

    if (ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord))) {
      ML_PIC_PIXEL0(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 0;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL1(thin,coord))) {
      ML_PIC_PIXEL1(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 1;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord))) {
      ML_PIC_PIXEL2(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 2;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL3(thin,coord))) {
      ML_PIC_PIXEL3(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 3;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord))) {
      ML_PIC_PIXEL4(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 4;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL5(thin,coord))) {
      ML_PIC_PIXEL5(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 5;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord))) {
      ML_PIC_PIXEL6(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 6;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL7(thin,coord))) {
      ML_PIC_PIXEL7(thin,coord) = ML_THIN_LINE_SET(new);
      dir = 7;
    }

    if (dir != ML_DIRECTB_UNKNOWN)
      thin->p[coord] = ML_THIN_THIN_SET(dir);
  }
}


static void strip (MLPictureUI8 *thin)
{
  guint8 round;
  gboolean change;
  gint full;
  MLCoord *row_last2, *row_last, *row_curr, *tmp;
  MLCoord row, col, coord, row_last2_count, row_last_count, row_curr_count;

#ifdef DEBUG
  g_message ("ztenuji ...");
#endif

  row_last2 = g_new0 (MLCoord, thin->cols);
  row_last2_count = 0;

  row_last = g_new0 (MLCoord, thin->cols);
  row_last_count = 0;

  row_curr = g_new0 (MLCoord, thin->cols);
  row_curr_count = 0;
 
  round = 0; 

  do {
    change = FALSE;
    if (round < 127) round++;
    
#ifdef DEBUG
    g_print (".");
#endif

    for (row = 1; row < thin->rows; row++) {
      for (col = 1; col < (thin->cols - 1); col++) {
	coord = ML_PIC_COORD(thin,row,col);
	
	if (ML_THIN_LINE(thin->p[coord])) { 
	  full = 
	    (ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)) ? 1:0) +
	    (ML_THIN_LINE(ML_PIC_PIXEL1(thin,coord)) ? 1:0) +
	    (ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord)) ? 1:0) +
	    (ML_THIN_LINE(ML_PIC_PIXEL3(thin,coord)) ? 1:0) +
	    (ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord)) ? 1:0) +
	    (ML_THIN_LINE(ML_PIC_PIXEL5(thin,coord)) ? 1:0) +
	    (ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord)) ? 1:0) +
	    (ML_THIN_LINE(ML_PIC_PIXEL7(thin,coord)) ? 1:0);
	  
	  if (full >= 2 && full <= 6 && Z0(thin,coord) == 1 &&
	      (!ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)) || 
	       !ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord)) ||
	       !ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord)) ||
	       Z0(thin,ML_PIC_COORD0(thin,coord)) != 1) &&
	      (!ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)) ||
	       !ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord)) ||
	       !ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord)) ||
	       Z0(thin,ML_PIC_COORD2(thin,coord)) != 1)) 
	    /* v tomto bode dochazi ke zmene */
	    row_curr[row_curr_count++] = coord;
	}
      }
      
      /* posun se o radku */
      if (row_last2_count) {
	change_thin (thin, row_last2, row_last2_count, round);
	change = TRUE;
      }
      
      tmp = row_last2;
      row_last2 = row_last;
      row_last2_count = row_last_count;
      
      row_last = row_curr;
      row_last_count = row_curr_count;

      row_curr = tmp;
      row_curr_count = 0;
    }

    /* na poslednim radku nesmi byt co ztencovat !! */
    g_assert (row_last_count == 0);

    if (row_last2_count) {
      change_thin (thin, row_last2, row_last2_count, round);
      change = TRUE;
    }

    row_last2_count = 0;

  } while (change);

  g_free(row_curr);
  g_free(row_last);
  g_free(row_last2);

#ifdef DEBUG
  g_print ("\n");
  g_message (" ... zteneno.");
#endif
}



static void strip_corners (MLPictureUI8 *thin)
{  
  MLCoord coord;

#ifdef DEBUG
  g_message ("odstranuji \"ruzky\" ...");
#endif
    
  for (coord = 0; coord < ML_PIC_SIZE(thin); coord++) {
    if (!ML_THIN_LINE(thin->p[coord])) continue;
      
    if (ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)) && 
	ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord)) && 
	! ML_THIN_LINE(ML_PIC_PIXEL5(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord))) {
      thin->p[coord] = ML_THIN_THIN_SET(0);
      continue;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord)) && 
	ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord)) && 
	! ML_THIN_LINE(ML_PIC_PIXEL7(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord))) {
      thin->p[coord] = ML_THIN_THIN_SET(2);
      continue;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord)) && 
	ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)) && 
	! ML_THIN_LINE(ML_PIC_PIXEL1(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord))) {
      thin->p[coord] = ML_THIN_THIN_SET(4);
      continue;
    }

    if (ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord)) && 
	ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord)) && 
	! ML_THIN_LINE(ML_PIC_PIXEL3(thin,coord)) &&
	! ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord))) 
      thin->p[coord] = ML_THIN_THIN_SET(6);
  }

#ifdef DEBUG
  g_message (" ... hotovo.");
#endif
}



MLPictureUI8* ml_pic_thin (const MLPictureSep *pic, MLSeparations layer)
{
  MLPictureUI8 *thin;
  MLCoord i;

  thin = g_new (MLPictureUI8, 1);
  thin->rows = pic->rows;
  thin->cols = pic->cols;
  thin->p = g_new0 (guint8, ML_PIC_SIZE(thin));
  
#ifdef DEBUG
  g_message ("plnm '.thin'");
#endif

  for (i = 0; i < ML_PIC_SIZE(thin); i++)
    if (pic->p[i] & layer) 
      thin->p[i] = ML_THIN_LINE_SET(1);
  
  strip (thin);
  strip_corners (thin);
  
  return thin;
}


#define INSPECT_WAY(thin,coord,dir)		G_STMT_START{		\
	if (ML_THIN_LINE(ML_PIC_PIXEL##dir(thin,coord))) { 		\
	  direct = dir; ways++;}		}G_STMT_END

static MLLineAtom* trace_line (MLPictureUI8 *thin, MLCoord coord0)
{
  GByteArray *line, *widths; 
  MLLineAtom *out;
  guint8 direct, tmp;
  gint8 ways;
  MLCoord coord, coord1;
  guint width;
  guint len, i;
  gboolean first;
#ifdef G_HAVE_GINT64
  guint64 diff;
#else
  double diff;
#endif

#ifdef DEBUG
  g_print (".");
#endif
  
  coord = coord1 = coord0;
  line = g_byte_array_new ();
  widths = g_byte_array_new ();
  direct = 0;
  width = 0;
  first = TRUE;

  /* FIXME: pouzit sirku */

  for (;;) {
    /* kudy kudy cesticka? */ 
    tmp = ML_THIN_LINE_GET(thin->p[coord]);

    width += tmp;
    g_byte_array_append (widths, &tmp, 1);

    ways = 0;

    INSPECT_WAY(thin,coord,2);
    INSPECT_WAY(thin,coord,1);
    INSPECT_WAY(thin,coord,0);
    INSPECT_WAY(thin,coord,7);
    INSPECT_WAY(thin,coord,6);
    INSPECT_WAY(thin,coord,5);
    INSPECT_WAY(thin,coord,4);
    INSPECT_WAY(thin,coord,3);

    if (ways == 0 || (ways > 1 && !first)) break;

    first = FALSE;
    line = g_byte_array_append (line, &direct, 1);
    thin->p[coord] = ML_THIN_CONST_LINE_NO_LINE;

    coord1 = coord;
    switch (direct) {
      case 0: coord = ML_PIC_COORD0(thin,coord); break;
      case 1: coord = ML_PIC_COORD1(thin,coord); break;
      case 2: coord = ML_PIC_COORD2(thin,coord); break;
      case 3: coord = ML_PIC_COORD3(thin,coord); break;
      case 4: coord = ML_PIC_COORD4(thin,coord); break;
      case 5: coord = ML_PIC_COORD5(thin,coord); break;
      case 6: coord = ML_PIC_COORD6(thin,coord); break;
      case 7: coord = ML_PIC_COORD7(thin,coord); break;
    }
  }
 

  /* opracuj nalezenou cesticku */
  if (ways == 0) {
    /* konec linie */
    thin->p[coord] = ML_THIN_CONST_LINE_NO_LINE;
      
    len = line->len;
    coord1 = coord;
  } else {
    /* ways > 1 => jsem na krizovatce */
    width -= ML_THIN_LINE_GET(thin->p[coord]);

    thin->p[coord] = ML_THIN_CONST_CROSS;
    len = line->len - 1;

    if (ML_THIN_LINE(ML_PIC_PIXEL0(thin,coord)))
	ML_PIC_PIXEL0(thin,coord) = ML_THIN_CONST_CROSS;
    if (ML_THIN_LINE(ML_PIC_PIXEL1(thin,coord)))
	ML_PIC_PIXEL1(thin,coord) = ML_THIN_CONST_CROSS;
    if (ML_THIN_LINE(ML_PIC_PIXEL2(thin,coord)))
	ML_PIC_PIXEL2(thin,coord) = ML_THIN_CONST_CROSS;
    if (ML_THIN_LINE(ML_PIC_PIXEL3(thin,coord)))
	ML_PIC_PIXEL3(thin,coord) = ML_THIN_CONST_CROSS;
    if (ML_THIN_LINE(ML_PIC_PIXEL4(thin,coord)))
	ML_PIC_PIXEL4(thin,coord) = ML_THIN_CONST_CROSS;
    if (ML_THIN_LINE(ML_PIC_PIXEL5(thin,coord)))
	ML_PIC_PIXEL5(thin,coord) = ML_THIN_CONST_CROSS;
    if (ML_THIN_LINE(ML_PIC_PIXEL6(thin,coord)))
	ML_PIC_PIXEL6(thin,coord) = ML_THIN_CONST_CROSS;
    if (ML_THIN_LINE(ML_PIC_PIXEL7(thin,coord)))
	ML_PIC_PIXEL7(thin,coord) = ML_THIN_CONST_CROSS;
  }

  out = ml_lineAtom_new (len);
  out->tip[0] = coord0;
  out->tip[1] = coord1;
#ifdef G_HAVE_GINT64
  out->width = ((guint64)width * ML_FIXED_1) / (len+1);
#else
  out->width = (guint)((1.0 * width/(len+1)) * ML_FIXED_1);
#endif


  diff = 0; 

  if (len) {
    for (i = 0; i < len; i++)
      diff += ABS_DIFF(ML_FIXED_1 * widths->data[i],out->width);
    
    diff /= len;
  }
  
  out->diff_width = diff;
  
  if (len) memcpy (out->data, line->data, len);
  
  g_byte_array_free (widths, TRUE);
  g_byte_array_free (line, TRUE);
  
  return out;
}
  


MLAtoms * ml_pic_find_atoms (MLPictureUI8 *thin)
{
  MLAtoms* atoms;
  MLLineAtom *atom;
  MLCoord coord;


#ifdef DEBUG
  g_message ("Hledm linie ...");
#endif
  
  atoms = ml_atoms_new ();

  for (coord = 0; coord < ML_PIC_SIZE(thin); coord++)
    if (ML_THIN_LINE(thin->p[coord])) {
      atom = trace_line (thin, coord);
      ml_atoms_add_atom (atoms, atom);
    }
  
#ifdef DEBUG
  g_print ("\n");
  g_message (" ... dohledno.");
#endif
  
  return atoms;
}
