/*
 *   MAPA - test ztencovani
 *
 *   (c) 2001 Jan Lana (jlan3028@ss1000.ms.mff.cuni.cz)
 *
 *   $Id: thin.c,v 1.1 2000/12/09 17:29:40 mapa Exp $
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

#include "ml.h"
#include "mlt.h"


void G_GNUC_NORETURN fatal_error (char *msg, ...);


int main (int argc, char **argv)
{
  gint in;
  MLPictureSep *pic;
  MLPictureUI8 *thin;
  MLSeparations mask;
  gchar *fn;

  
  if (argc < 2 || argc > 3)
    fatal_error ("Usage: %s mask [pclfile]\nmask: one from\n"
	"  0 LighttYELLOW\n  1 DarkYELLOW\n  2 LightGREEN\n"
        "  3 MiddleGREEN\n  4 DarkGREEN\n  5 LightBLUE\n"
	"  6 DarkBLUE\n  7 LightBROWN\n  8 DarkBROWN\n  9 BLACK\n  10 ERR\n",
	argv[0]);

  if (argc == 3) {
    in = open (argv[2], O_RDONLY);

    if (in < 0)
      fatal_error ("%s: %s", argv[0], argv[2]);

  } else
    in = 0;

  mask = (MLSeparations)(1<<strtoul (argv[1], NULL, 0));

  pic = ml_pic_read (in);
  if (pic == NULL)
    fatal_error ("Read error");
  
  thin = ml_pic_thin (pic, mask);

  fn = g_strdup_printf ("%s.png", argv[0]);
  if (ml_pic_write (fopen (fn, "wb"), thin, thin, thin) < 0)
    fatal_error ("Write error (%s)", fn);
  g_free (fn);
  
  ml_pic_free (thin);
  ml_pic_free (pic);

#ifdef DEBUG
  g_blow_chunks ();
  g_mem_chunk_info ();
  g_mem_profile ();
#endif

  return 0;
}
